""" SCRIPT CONFIGURATION PART """
messages = {
    10: '10 kills remaining\nLeader: ${attacker}',
    5: '5 kills remaining\nLeader: ${attacker}',
    1: '1 KILL REMAINING!\nLeader: ${attacker}',
    }

sounds = {
    10: 'killremain/killsremain 10.mp3',
    5: 'killremain/killsremain 5.mp3',
    1: 'killremain/killsremain 1.mp3',
    }
""" END OF CONFIGURATION PART """

import es
import gamethread
import usermsg

info = es.AddonInfo()
info.name = "Kills remaining"
info.basename = "kill_cd"
info.version = "1.2"
info.description = "Shows messages and optionally plays sounds when there are 10, 5 and 1 kill remaining in the round"

triggered = set()

mp_fraglimit = es.ServerVar('mp_fraglimit')
round_fraglimit = es.ServerVar('round_fraglimit', 0, 'Limit of kills per round (addon %s)' % info.name)
mp_chattime = es.ServerVar('mp_chattime')

def es_map_start(event_var):
    for sound in sounds.values():
        es.stringtable('downloadables', 'sound/'+sound)
    triggered.clear()

def player_death(event_var):
    attacker = int(event_var['attacker'])
    fraglimit = int(round_fraglimit) or int(mp_fraglimit)
    if attacker and fraglimit:
        kills = int(event_var['es_attackerkills']) + 1 # lazy engine :P
        remaining = fraglimit - kills
        if remaining not in triggered:
            if remaining in sounds:
                es.emitsound('player', attacker, sounds[remaining], 1.0, 0.0)
            if remaining in messages:
                centermessage(messages[remaining].replace('${attacker}', es.getplayername(attacker)))
            triggered.add(remaining)
        if remaining <= 0:
            end_round(attacker)

def end_round(attacker):
    if int(round_fraglimit):
        for userid in es.getUseridList():
            es.setplayerprop(userid, 'CBaseEntity.movetype', 0)
        toggle_scores(1)
        gamethread.delayed(int(mp_chattime), toggle_scores, 0)
        es.server.insertcmd('mp_restartgame %d' % int(mp_chattime))

def toggle_scores(state):
    usermsg.showVGUIPanel(es.getUseridList(), 'scores', state)

def centermessage(text):
    es.usermsg('create', 'KCDCMSG', 'TextMsg')
    es.usermsg('write', 'byte', 'KCDCMSG', 4)
    es.usermsg('write', 'string', 'KCDCMSG', text)
    for uid in es.getUseridList():
        es.usermsg('send', 'KCDCMSG', uid, 1)
    es.usermsg('delete', 'KCDCMSG')
